﻿using System;
using System.Linq;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;

namespace Altairis.ResourceDemo.Controls {

    public enum FlagIconColor {
        Blue = 0,
        Green = 1,
        Orange = 2,
        Pink = 3,
        Purple = 4,
        Red = 5,
        Yellow = 6
    }

    public class FlagIcon : Control {

        // Constants
        private const string STYLE_RESOURCE_NAME = "Altairis.ResourceDemo.Controls.Resources.InlinedFlags.css";
        private const string IMAGE_RESOURCE_NAME_FORMAT = "Altairis.ResourceDemo.Controls.Resources.Flag{0}.png";
        private const string ALTERNATE_TEXT_FORMAT = "{0} flag";

        // Constructors

        public FlagIcon() {
            this.FlagColor = FlagIconColor.Blue;
        }

        // Configuration properties

        public FlagIconColor FlagColor {
            get { return (FlagIconColor)this.ViewState["FlagColor"]; }
            set { this.ViewState["FlagColor"] = value; }
        }

        // Methods

        protected override void CreateChildControls() {
            base.CreateChildControls();

            // Add image linking to web resource
            var resourceName = string.Format(IMAGE_RESOURCE_NAME_FORMAT, this.FlagColor);
            this.Controls.Add(new Image {
                Width = Unit.Pixel(16),
                Height = Unit.Pixel(16),
                ImageUrl = this.Page.ClientScript.GetWebResourceUrl(this.GetType(), resourceName),
                AlternateText = "icon",
                ToolTip = string.Format(ALTERNATE_TEXT_FORMAT, this.FlagColor)
            });

        }

    }
}
